import lodash from "lodash";
const { uniq } = lodash;
import { inspect } from "util";

const paths = [
  ["TestButton", "primary", "md", ":none", "paddingTop", 0],
  ["TestButton", "primary", "md", ":none", "paddingBottom", 0],
  ["TestButton", "primary", "md", ":hover", "paddingTop", 0],
  ["TestButton", "primary", "md", ":hover", "paddingBottom", 0],
  ["TestButton", "primary", "lg", ":none", "paddingTop", 0],
  ["TestButton", "primary", "lg", ":none", "paddingBottom", 0],
  ["TestButton", "primary", "lg", ":hover", "paddingTop", 0],
  ["TestButton", "primary", "lg", ":hover", "paddingBottom", 0],
  ["TestButton", "secondary", "md", ":none", "paddingTop", 0],
  ["TestButton", "secondary", "md", ":none", "paddingBottom", 0],
  ["TestButton", "secondary", "md", ":hover", "paddingTop", 0],
  ["TestButton", "secondary", "md", ":hover", "paddingBottom", 0],
  ["TestButton", "secondary", "lg", ":none", "paddingTop", 0],
  ["TestButton", "secondary", "lg", ":none", "paddingBottom", 0],
  ["TestButton", "secondary", "lg", ":hover", "paddingTop", 0],
  ["TestButton", "secondary", "lg", ":hover", "paddingBottom", 0],
  ["Bottomline", "default", "bar", "fontSize"],
  ["Bottomline", "solo", "bar", "fontSize"],
  ["testContainer", "paddingTop"],
  ["testContainer", "paddingBottom"]
];

export const createPathsMap = paths => {

  const tabs = uniq(paths.flat(1));

  return [
    tabs,
    paths.map(path => path.map(tab => tabs.indexOf(tab)))
  ]

};

export const getPaths = pathsMap => {
  const [tabs, indexes] = pathsMap;
  return indexes.map(index => index.map(i => tabs[i]));
};

export const optimizePaths = pairs => {
  return pairs.map(pair => {
    const endValue = pair[0];
    const themeSets = pair[1];
    return [
      endValue,
      themeSets.map(([themeIndexes, paths]) => [
        themeIndexes,
        createPathsMap(paths)
      ])
    ]
  });
};

// const pathsMap = createPathsMap(paths);

// console.log(inspect(pathsMap, { depth: 100 }));

// console.log(inspect(getPaths(pathsMap), { depth: 100 }));

// console.log(`paths bytes:`, JSON.stringify(paths).length);
// console.log(`pathsMap bytes:`, JSON.stringify(pathsMap).length);
