import { ot } from "../om/index.mjs";
import { rx } from "../om/rx.mjs";

export const isEndpoint = node =>
   node && node.hasOwnProperty("value") && node.hasOwnProperty("type");

export const isEndpointsCollection = node =>
   ot(node) === "object" && Object.values(node).every(value => isEndpoint(value));

export const hasEndpoints = node => {
   if (ot(node) !== "object") return;
   const keys = Object.keys(node).filter(key =>
      ot(node[key]) === "array"
         ? node[key].some(e => isEndpoint(e))
         : isEndpoint(node[key])
   );
   return keys.length > 0 ? keys : undefined;
};

export const hasRefs = endpoint => rx.ref.pass.test(endpoint.value);

export const isCalc = endpoint => rx.calc.pass.test(endpoint.value);

export const isSingleRef = endpoint => ot(endpoint.value)==="string" && rx.ref.single.pass.test(endpoint.value.trim());

