import { ot } from "../om/index.mjs";

export const px = value => ot(value) === "string" && !/px$/.test(value.trim()) && value !== "0"
? `${value}px`
: value;

export const styles = [
   /* [
      ["verticalPadding", "horizontalPadding"],
      args => ({ padding: `${px(args[0])} ${px(args[1])}` }),
   ], */
   [
      ["verticalPadding"],
      args => ({ paddingTop: px(args[0]), paddingBottom: px(args[0]) }),
   ],
   [
      ["horizontalPadding"],
      args => ({ paddingLeft: px(args[0]), paddingRight: px(args[0]) }),
   ],
   [
      ["padding"],
      args => ({ padding: px(args[0]) }),
   ],
   /* [
      ["verticalMargin", "horizontalMargin"],
      args => ({ margin: `${px(args[0])} ${px(args[1])}` }),
   ], */
   [
      ["verticalMargin"],
      args => ({ marginTop: px(args[0]), marginBottom: px(args[0]) }),
   ],
   [
      ["horizontalMargin"],
      args => ({ marginLeft: px(args[0]), marginRight: px(args[0]) }),
   ],
   [
      ["margin"],
      args => ({ margin: px(args[0]) }),
   ],
   [
      ["itemSpacing"],
      args => ({ gap: px(args[0]) }),
   ],
   [
      ["textCase"],
      args => ({ textTransform: args[0] }),
   ],
   [
      ["fontWeights"],
      args => ({ fontWeight: args[0] }),
   ],
   [
      ["lineHeights"],
      args => ({ lineHeight: args[0] }),
   ],
   [
      ["fontSizes"],
      args => ({ fontSize: args[0] }),
   ],
   [
      ["fontFamilies"],
      args => ({ fontFamily: args[0] }),
   ],
   [
      ["fill"],
      (args, textNode) => ({ [textNode ? "color" : "backgroundColor"]: args[0] }),
   ],
   [
      ["border"],
      args => ({ borderColor: args[0] }),
   ],
   [
      ["borderWidthTop"],
      args => ({ borderTopWidth: px(args[0]) }),
   ],
   [
      ["borderWidthBottom"],
      args => ({ borderBottomWidth: px(args[0]) }),
   ],
];
