import lodash from "lodash";
import fse from "fs-extra";
import { inheritComponentStates, inheritTokenSets } from "./inherit.mjs";
const { camelCase } = lodash;
const { readJSON, outputJSON } = fse;

  
export const assembleTheme = async (theme, path) => {
  const promises = theme.tokenSets.map((tokenSet) =>
    readJSON(`${path.source}/${tokenSet}.json`)
    
    /* .then((tokenSet) =>
      tokenSet.hasOwnProperty("breakpoints")
        ? createBreakpoints(tokenSet, Object.keys(breakpoints))
        : tokenSet
    ) */

  );

  const tokenSets = await Promise.all(promises);

  const statefulTokenSets = tokenSets.map(tokenSet => inheritComponentStates(tokenSet));

  const res = { [theme.name]: inheritTokenSets(statefulTokenSets) };

  await outputJSON(
    `${path.destination}/log/${camelCase(theme.name)}.json`,
    res,
    { spaces: 2 }
  );

  return res;
};
