import { createBreakpoints } from "../om/breakpoints.mjs";
import { expandToEndpoints } from "../om/expand.mjs";
import { convertToArrays, pipe } from "../om/index.mjs";
import { makeIds, removeUnderscored } from "../om/om.mjs";

export const pipeRaw = (node, breakpointNames) =>
  pipe(
    expandToEndpoints,
    (node) => createBreakpoints(node, breakpointNames),
    convertToArrays,
    removeUnderscored,
    makeIds
  )(node);
